{ ********************************************************************** }
{ Brettmanagers von !!MB2 - Aktionsteil auf Antworten vom
  Mailbox-Brettmanager

  Aufgaben
  - Bearbeiten der eingehenden Listen und Erzeugen einer !!MB-kompatiblen
    Brettliste

    convertboxlist2mblist
    convertorderedlist2mblist
     infile  -  enthlt die Brettlisten, die whrend des letzten Netzan-
                rufes geschickt wurden. Die Nachricht(en) sind "pur"
                exportiert.
                Besteht die Liste aus mehreren Teilen, oder sind mehrere
                identische Listen mit dem Netzanruf angekommen, so werden
                sie chronologisch aneinanderkopiert.
     outfile -  In diese Datei mchte !!MB die !!MB-kompatible Brettliste
                kopiert haben.
     netztyp -  die interne Netznummer in !!MB
                Definiert ist:
                zerberus  = 1; Z38
                magic     = 2; Magic1.6 (oder so)
                maus      = 3;
                fido      = 4;
                alphabox  = 5;
                zconnect  = 6;
                amnet     = 7;
                myboxmail = 8; krankbox
                uucp      = 9;
     msgstyle - Mailboxprogramm-Typ definieren
                immer Null.

     absender - Der vollstndige Name des Absenders, soweit es sowas gibt,
                <username>@<box>.<do>.<main>. Ggf. sind Leerzeichen bzw.
                "kranke" Adressen zu erwarten.

     betreff  - Das Betreff der Nachricht

     box      - Der !!MB-interne Pollboxname

    !!MB bernimmt das Aufrumen (spteres Lschen von INFILE)

    "convertboxlist2mblist" erzeugt eine Liste der bestellbaren Bretter
    einer Box (also eine Liste der Bretter, die die Box Ihnen anbietet),
    "convertorderedlist2mblist" erzeugt eine Liste der Bretter, die Sie
    bestellt haben.
    Das Format der Listen, die Sie dabei jeweils von der Box bekommen
    (infile) kann stark unterschiedlich sein.

    Fr alle Netze (Ausnahme: Z-Netz (Z38, ZConnect)) kann aus einer Brett-
    liste sowohl die Liste aller Bretter als auch die Liste der bestellten
    Bretter generiert werden.
    Fr Z-Netz ist deshalb eine Sonderbehandlung sowohl im BrettMgr.MBE
    als auch in !!MessageBase selber notwendig.

    Fr Unix-style-Messages ist !!MB so nett und konvertiert die Nachrichten
    von LF->CRLF.

    Mit der Funktion "loadboxsubtype" kann ber die Datei BRMGR.DAT fr
    einzelne Boxen eine Sonderbehandlung implementiert werden.

    "loadboxsubtype" liefert fr "boxname" einen "msgstyle" zurck, der nach
    folgenden Regeln definiert ist:

    - Nummern 0
      Es existiert keine Box mit "boxname" in BRMGR.DAT

    - Nummern zwischen 00001..00999
      intern benutzt, nicht verwenden.

    - Nummern zwischen 01000..09999
      In "localconvertboxlist2mblist" wird zu "subtyp" kein Offset addiert

    - Nummern zwischen 10000..19999
      In "localconvertboxlist2mblist" wird zu "subtyp" ein Offset addiert:
      msgstyle=0 -> +00000  ->  10000..19999
      msgstyle=1 -> +10000  ->  20000..29999

    - Nummern zwischen 30000..65500
      unbenutzt

    Und "localconvertboxlist2mblist" verzweigt dann an die entsprechenden
    Stellen.
    Dieser Stre ist nur ntig, wenn spezielle Boxsoftware bestimmte
    Exporter bentigt.

    Definiert sind derzeit folgende Sonderexporter:
     <noch leer>


  - Reaktion auf allerlei Antworten

    Nix.


   Ein wichtiger Hinweis

    Jedes ndern der Prozedurkpfe ist mit an Sicherheit grenzender Wahr-
    scheinlichkeit tdlich. Wirklich. Die Definitionen in !!MB und dieser
    DLL mssen bereinstimmen...


   History

    0.19 19.12.93 Erste Erschaffung
    0.21 07.08.94 MSGSTYLE eingebaut
    0.25 21.08.94 STYLUS eingebaut
                  Umstellung auf "Brettlisten" und "Liste der Bestellten"
    0.30 03.09.94 "loadboxsubtype" angedacht
                  (hauptschlich nur Doku, Vorbereitung fr Connectline?)

    0.35 04.10.94 Exporter fr UUCP eingebaut
    0.36 05.10.94 Exporter fr UUCP korrigiert, ergnzt, validiert
    0.37 04.02.95 Exporter fr UUCP korrigiert
                  STANDALONE-Define eingebaut
    0.41 12.04.95 nderungen im Fido-Teil
                  Untersttzung von Squish und Fastecho eingebaut
    0.42 13.06.95 nderungen im Fido-Teil
                  Anpassungen der Fastecho-Geschichten (Shit!)
    0.43 06.08.95 Anpassung an ZC 3.1-Maps
    0.44 31.08.95 Anpassung an hirnkranke ZConnect-Amiga-Software

   Urheberrechte

    Smtliche Rechte an diesem Quelltext liegen bei der KAP Holger Lembke.

    Eine Verffentlichung, Verwendung in anderen Produkten oder sonstige
    Verwertungen sind ohne Genehmigung der KAP Holger Lembke nicht zulssig.

    KAP Dipl.-Ing. Holger Lembke
    Hamburger Strae 284
    38114 Braunschweig

    Braunschweig, im Dezember 1993
                                                                         }
{ ********************************************************************** }

{ $ define standalone}

{hier wird definiert, da der alte Zerberus genommen wird.}
{$define goodoldzerberus}

{ $A+,B-,D-,E-,F-,G+,I-,L-,N-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$I-}
{$ifndef standalone}
library BRMGR;
{$endif}

uses dos;

{$D !!MessageBase 2.0//COPYRIGHT KAP Holger Lembke;Hamburger Strae 284;38114 Braunschweig}


Const  brmgrversion  =  'BRMGR 0.44';

(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
function stupcase(t : string):string;
Var i : byte;
begin
  for i:=1 to length(t) do
    t[i]:=upcase(t[i]);
  stupcase:=t;
end;

(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
procedure loadboxsubtype(boxname : string; Var msgstyle : word);
Var datei  : text;
    zeile  : string;
    fehler : integer;
begin
  boxname:=stupcase(boxname);

  assign(datei,'BRMGR.DAT');
  reset(datei);
  if (ioresult=0) then begin
    repeat
      readln(datei,zeile);
      zeile:=stupcase(zeile);
      if (zeile=boxname) then begin
        readln(datei,zeile);
        val(zeile,msgstyle,fehler);
       end else
        readln(datei);
    until (ioresult<>0) or (eof(datei));
    close(datei);
  end;
end;

(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
function closefilesize(Name : String):Longint;
Var sr    : searchrec;
begin
  closefilesize:=-1;

  findfirst(name,anyfile,sr);
  if (doserror=0) then
    closefilesize:=sr.size;
end;

(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
procedure localconvertboxlist2mblist(infile, outfile    : string;
                                     netztyp, msgstyle  : word;
                                     absender, betreff,
                                     pollbox            : string;
                                     stylus             : byte);
{$ifndef standalone} export; {$endif}
Var subtyp : word;
{STYLUS legt den Exporttyp fest:

  0 - Brettliste
  1 - Liste der bestellten Bretter }

  procedure del_a_space(Var wie : String);
  begin
    while (length(wie)>0) and (pos(' ',wie)>0) do
      delete(wie,pos(' ',wie),1);
  end;


  procedure open(var aus : text);
  begin
    append(aus);
    if (ioresult<>0) then
      rewrite(aus);
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportmaus;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    if (ioresult=0) then begin
      assign(ein,infile);
      reset(ein);

      repeat
(*
1234567890123456789012345678901234567890
   12345678901234
:+ MAUS.GRP    Vorschlge und Diskussion zu neuen Netzgruppen
:+ MAUS.INFO   Wichtige Informationen fr ALLE MausNet-User!
:  MAUS.TEST   Der Praxis-Test fr neue Gruppenvorschlge
*)
        readln(ein,zeile);
        if (zeile<>'') and (zeile[1]=':') then
          delete(zeile,1,1);

        if (zeile<>'') and (zeile[3]<>' ') and
           ( (stylus=0) or
             ( (stylus=1) and (zeile[1]='+') )
           ) then begin
          delete(zeile,1,2);

          zeile[12]:=',';
          i:=11;

          while(zeile[i]=' ') do begin
            delete(zeile,i,1);
            dec(i);
          end;
          writeln(aus,zeile);
        end;
      until (eof(ein));

      close(aus);
      close(ein);
    end;
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportzerberus_old;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    if (ioresult=0) then begin
      assign(ein,infile);
      reset(ein);

      repeat
        readln(ein,zeile);
{war:
        while (length(zeile)>0) and (zeile[1] in ['-','+','!',' ']) do
 ist:
}
        if (length(zeile)>0) and (zeile[1] in ['-','+','!',' ']) then
{weil:
 kranke systeme beginnen den Brettnamen immer ohne fhrendes '/' und
 haben als Brettnamen dann ein '!-' oder hnlichen Schwachsinn als Anfang
}
          delete(zeile,1,1);
        i:=1;
        while (i<length(zeile)) and (zeile[i]<>' ') do
          inc(i);
        delete(zeile,i+1,255);

        if (zeile[1]<>'/') then
          zeile:='/'+zeile;

        if (length(zeile)>4) then
          writeln(aus,zeile);
      until (eof(ein));

      close(aus);
      close(ein);
    end;
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportzerberus_new;
  Var ein, aus : text;
      i        : byte;
      youget   : boolean;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    if (ioresult=0) then begin
      assign(ein,infile);
      reset(ein);

      repeat
        readln(ein,zeile);

        if (zeile<>'') and
           (zeile[1] in ['+',' ','-','!']) then begin
          youget:=zeile[1] in ['+','!'];

          delete(zeile,1,2);

          if (stylus=0) or
             ( (stylus=1) and (youget)) then
            writeln(aus,zeile);
        end;
      until (eof(ein));

      close(aus);
      close(ein);
    end;
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportmagic;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    if (ioresult=0) then begin
      assign(ein,infile);
      reset(ein);
(*
         1         2         3         4         5         6         7
123456789012345678901234567890123456789012345678901234567890123456789012
FIDO\F-386ER                             1496 M-Net           unbestellt
FIDO\F-KOMMERZ.GER                       1473 M-Net           unbestellt
*)
      repeat
        readln(ein,zeile);
        if (zeile<>'') and (zeile[1]<>'$') and
           ( (stylus=0) or
             ((stylus=1) and (upcase(zeile[63])='B')) ) then begin
          write(aus,copy(zeile,42,4),',/');
          zeile:=copy(zeile,1,41);
          del_a_space(zeile);
          writeln(aus,zeile);
        end;

      until (eof(ein));

      close(aus);
      close(ein);
    end;
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportfido;
  Const kickoffchars = [' ','*','+','-'];
  Var ein, aus : text;
      i, j     : byte;
      zeile,
      zeile2   : string;

    procedure muellvornewegmachen;
    begin
      while (zeile<>'') and
            (zeile[1] in kickoffchars) do
        delete(zeile,1,1);
    end;

  begin
    assign(aus,outfile);
    open(aus);

    assign(ein,infile);
    reset(ein);
    readln(ein,zeile);

    absender:=stupcase(absender);

    if (ioresult=0) then begin
      repeat
        readln(ein,zeile);

        if (length(zeile)>4) then begin
          {fastecho-trick: ein zustzliches leerzeichen entfernen}
          if (zeile[2]=' ') then
            delete(zeile,2,1);

          if (zeile<>'') and (zeile[1] in [' ','+','-','*'])
                         and (zeile[2] in ['A'..'Z','0'..'9'])then begin
            if (stylus=0) or
               ( (stylus=1) and (zeile[1] in ['+','*']) ) then begin

              {fastecho-hack}
              i:=pos(' .',zeile)*pos('. ',zeile);
              if (i>0) then begin
                i:=pos(' ..',zeile);
                if (i>0) then begin
                  delete(zeile,i,255);
                end;

                muellvornewegmachen;

               end else begin
                {squish-hack}
                i:=pos('[',zeile);
                j:=pos(']',zeile);
                if (i>0) and
                   (i+2=j) then begin
                  zeile2:=copy(zeile,j+3,255);
                  zeile:=copy(zeile,1,i-1);
                  while (zeile<>'') and
                        (zeile[length(zeile)] in [' ']) do
                    dec(zeile[0]);
                  while (zeile2<>'') and
                        (zeile2[length(zeile2)] in ['"',' ']) do
                    dec(zeile2[0]);
                  zeile:=zeile+','+zeile2;

                  muellvornewegmachen;
                end else begin

                  {n, also AREAFIX oder GECHO}
                  muellvornewegmachen;

                  {...und wir haben eine Beschreibung}
                  if (length(zeile)>31) then begin
                    zeile[31]:=',';
                    i:=30;
                    while (zeile[i]=' ') do begin
                      delete(zeile,i,1);
                      dec(i);
                    end;
                  end;

                end;
              end;

              {endlich schreiben...}
              writeln(aus,zeile);
            end;
          end;
        end;
      until (eof(ein));
    end;

    close(aus);
    close(ein);
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportalphabox;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    assign(ein,infile);
    reset(ein);

    repeat
      readln(ein,zeile);
(*
Brettname                                     Code  Status      Typ  Bemerkung
-------------------------------------------------------------------------------
         1         2         3         4         5         6
1234567890123456789012345678901234567890123456789012345678901234567
BINAER\ATARI\Programminfo                     L022  unbestellt  TXT
BINAER\PC\AlphaBox-Tools                      B001  unbestellt  BIN
BINAER\PC\Pointprogramme                      BL07  unbestellt  BIN
BRAUNSCHWEIG\Sysops                           BS01  bestellt    TXT
BRAUNSCHWEIG\Sysops-Zerb                      BS09  bestellt    TXT
*)
      if (ioresult=0) then begin
        repeat
          readln(ein,zeile);

          if (zeile<>'') and
             ((copy(zeile,65,3)='BIN') or
              (copy(zeile,65,3)='TXT')) and
             ( (stylus=0) or
               ( (stylus=1) and (upcase(zeile[53])='B') ) ) then begin
            zeile:=copy(zeile,47,4)+','+zeile;

            delete(zeile,51,255);
            while (length(zeile)>0) and (zeile[length(zeile)]=' ') do
              dec(zeile[0]);
            writeln(aus,zeile);

          end;

        until (eof(ein));
        close(aus);
      end;
    until (eof(ein));

    close(ein);
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportamnet;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;
  begin
    assign(aus,outfile);
    open(aus);

    assign(ein,infile);
    reset(ein);

    if (ioresult=0) then begin
      repeat
        readln(ein,zeile);
        if (length(zeile)>6) and (zeile[1] in ['-','+','o','O']) then begin
          if (stylus=0) or ( (stylus=1) and (zeile[1]='+')) then begin
            i:=pos('\',zeile);
            while (i>0) do begin
              zeile[i]:='/';
              i:=pos('\',zeile);
            end;
            writeln(aus,copy(zeile,2,3),',',copy(zeile,6,255));
          end;
        end;
      until (eof(ein));
    end;

    close(aus);
    close(ein);
  end;

  (************************************************************************)
  (************************************************************************)
  procedure exportuucp;
  Var ein, aus : text;
      i        : byte;
      zeile    : string;

    procedure exportbrettliste;
{
# Stand: 23.9.94
alt.activism			Activities for activists
alt.activism.death-penalty	For people opposed to capital punishment.
alt.aldus.freehand		?
alt.alien.visitors		Space creatures ate my modem.
}
    begin
      assign(aus,outfile);
      open(aus);

      assign(ein,infile);
      reset(ein);

      if (ioresult=0) then begin
        repeat
          readln(ein,zeile);
          if (zeile<>'') and
             (zeile[1] in ['A'..'Z','a'..'z','0'..'9']) then begin
            if (stylus=0) then begin
              {backslash raus}
              i:=pos('\',zeile);
              while (i>0) do begin
                zeile[i]:='/';
                i:=pos('\',zeile);
              end;

              {tabs suchen}
              i:=pos(#9,zeile);
              while (i>0) do begin
                zeile[i]:=' ';
                i:=pos(#9,zeile);
              end;

              {slash davor}
              if (zeile[1]<>'/') then
                zeile:='/'+zeile;

              {doppelleerzeichen lschen}
              i:=pos('  ',zeile);
              while (i>0) do begin
                delete(zeile,i,1);
                i:=pos('  ',zeile);
              end;

              {komma einfgen bzw. zu kurze Beschreibung lschen}
              i:=pos(' ',zeile);
              if (i>0) then begin
                if (i>=length(zeile)-1)
                  then delete(zeile,i,255)
                  else zeile[i]:=',';
              end;

              writeln(aus,zeile);
            end;
          end;
        until (eof(ein));
      end;

      close(aus);
      close(ein);

      {lschen, wenn leer}
      if (closefilesize(outfile)=0) then
        erase(aus);
    end;

    procedure exportmybrettliste;
{
#! rmail 1458 holger_lembke@master
From news Wed Oct  5 10:46:47 1994 remote from xmp
Received: by xmp (Smail3.1.28.1 #1)
	id m0qsSvt-0004omC; Wed, 5 Oct 94 10:46 MET
Message-Id: <m0qsSvt-0004omC@xmp>
Date: Wed, 5 Oct 94 10:46 MET
To: holger_lembke@master.priconet.de
From: changesys@xmp.priconet.de
Subject: your latest sys file entry

This is your latest sys file entry:

#
# System: master
#
master/master.priconet.de:xmp.software.allgemein,\
xmp.software.suche,\
xmp.system.info,\
xmp.priconet.ev,xmp.test,\
xmp.talk.usertreffen,\
xmp.talk.rezepte,\
xmp.talk.party,\
xmp.info.presse,\
xmp.fileinfo,\
xmp.archiv.rezepte/all,!local:f:

You will always get the following groups:

xmp.software.allgemein,\
xmp.software.suche,\
xmp.system.info,\
xmp.priconet.ev
braunschweig.newfiles,\
braunschweig.listen_plaene,\
braunschweig.kommerzielles,\
alt.sex.stories/all,!local:f:

You will always get the following groups:

xmp.software.allgemein,\
xmp.software.suche,\
xmp.system.info,\
}
   Var firstline : boolean;

      procedure handleline;
      Var i : byte;
          t : string;
      begin
        {sonderbehandlung 1. Zeile}
        if (firstline) and
           (pos('/',zeile)>0) then begin
          delete(zeile,1,pos(':',zeile));
          firstline:=false;
        end;

        {gltige zeilen mssen mind. einen punkt enthalten. Ist sicher nicht
         die optimale lsung. Ist der Header genormt??}
        if (pos('.',zeile)>0) then begin
          repeat
            i:=1;
            while (i<length(zeile)) and
                  (zeile[i]<>',') do
              inc(i);
            if (i=length(zeile)) and
               (pos('.',zeile)>0) then
              writeln(aus,zeile)
             else begin
              t:=copy(zeile,1,i-1);
              if (pos('/',t)>0) then
                delete(t,pos('/',t),255);
              if (pos('.',t)>0) then
                writeln(aus,t);
            end;
            delete(zeile,1,i);
            if (zeile<>'') and
               (zeile[1]='\') then
              delete(zeile,1,1);
          until (zeile='');
        end;
      end;

    begin
      assign(aus,outfile);
      open(aus);

      assign(ein,infile);
      reset(ein);

      firstline:=true;
      if (ioresult=0) then begin
        repeat
          readln(ein,zeile);
        until (eof(ein)) or
              (pos('/',zeile)>0);

        if (not eof(ein)) then begin
          handleline;
          repeat
            readln(ein,zeile);
            handleline;
          until (eof(ein));
        end;
      end;

      close(aus);
      close(ein);

      {lschen, wenn leer}
      if (closefilesize(outfile)=0) then
        erase(aus);
    end;

  begin
    if (stylus=0)
      then exportbrettliste
      else exportmybrettliste;
  end;


begin
  subtyp:=0;
  loadboxsubtype(pollbox,subtyp);

  if (subtyp>=10000) and (subtyp<=19999) then
    subtyp:=subtyp+10000;

{$ifdef goodoldzerberus}
  case subtyp of
    00000 : case netztyp of
              8,6,1      : exportzerberus_old;
              2          : exportmagic;
              3          : exportmaus;
              4          : exportfido;
              5          : exportalphabox;
              7          : exportamnet;
              9          : exportuucp;
            end;
  end;
{$else}
  case subtyp of
    00000 : case netztyp of
              8,1        : exportzerberus_old;
              2          : exportmagic;
              3          : exportmaus;
              4          : exportfido;
              5          : exportalphabox;
              6          : exportzerberus_new;
              7          : exportamnet;
              9          : exportuucp;
            end;
  end;
{$endif}
end;


(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
procedure convertboxlist2mblist(infile, outfile    : string;
                                netztyp, msgstyle  : word;
                                absender, betreff,
                                pollbox            : string);
{$ifndef standalone} export; {$endif}
begin
  localconvertboxlist2mblist(
    infile,outfile,netztyp,msgstyle,absender,betreff,pollbox,0);
end;


(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
procedure convertorderedlist2mblist(infile, outfile    : string;
                                    netztyp, msgstyle  : word;
                                    absender, betreff,
                                    pollbox            : string);
{$ifndef standalone} export; {$endif}
begin
  localconvertboxlist2mblist(
    infile,outfile,netztyp,msgstyle,absender,betreff,pollbox,1);
end;


(***************************************************************************)
(***************************************************************************)
(***************************************************************************)
function Brettmanagerversion:string; {$ifndef standalone} export; {$endif}
begin
  Brettmanagerversion:=brmgrversion;
end;


{$ifndef standalone}
exports
 {                                   !!Gro-Klein-Schreibung beachten!! }
  convertboxlist2mblist      index 1 name 'CONVERTBOXLIST2MBLIST',
  convertorderedlist2mblist  index 2 name 'CONVERTORDEREDLIST2MBLIST',
  Brettmanagerversion        index 3 name 'BRETTMANAGERVERSION';
{$endif}

{$ifdef standalone}
Var sr : searchrec;

{$endif}

begin

{$ifdef standalone}

{zum Testen der Fido-Exporter}
  findfirst('*.fid',anyfile,sr);
  while (doserror=0) do begin
    writeln('working: ',sr.name);
    convertboxlist2mblist(     sr.name,copy(sr.name,1,pos('.',sr.name))+'BRT',
                               4,0,'jajaja@jaja','hahahahha','xmp');

    convertorderedlist2mblist( sr.name,copy(sr.name,1,pos('.',sr.name))+'BRO',
                               4,0,'jajaja@jaja','hahahahha','xmp');
    findnext(sr);
  end;

{$endif}

end.